diff -Naurd cluster-3.0.0.rc2/cman/daemon/commands.c cluster-3.0.0.rc3/cman/daemon/commands.c
--- cluster-3.0.0.rc2/cman/daemon/commands.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/daemon/commands.c	2009-06-11 11:02:55.000000000 +0200
@@ -33,7 +33,6 @@
 #include "cnxman-private.h"
 #include "daemon.h"
 #include "barrier.h"
-#include "logging.h"
 #define OBJDB_API struct corosync_api_v1
 #include "cmanconfig.h"
 #include "nodelist.h"
@@ -287,7 +286,7 @@
 
 		newname = strdup(name);
 		if (newname) {
-			P_MEMB("replacing old node name %s with %s\n", newnode->name, name);
+			log_printf(LOGSYS_LEVEL_DEBUG, "memb: replacing old node name %s with %s\n", newnode->name, name);
 			free(newnode->name);
 			newnode->name = newname;
 		}
@@ -298,7 +297,7 @@
 
 	newnode->flags |= NODE_FLAGS_REREAD;
 
-	P_MEMB("add_new_node: %s, (id=%d, votes=%d) newalloc=%d\n",
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: add_new_node: %s, (id=%d, votes=%d) newalloc=%d\n",
 	       name, nodeid, votes, newalloc);
 
 	return newnode;
@@ -542,7 +541,7 @@
 		outbuf = *retbuf + offset;
 		einfo = (struct cl_extra_info *)outbuf;
 
-		P_MEMB("get_extrainfo: allocated new buffer\n");
+		log_printf(LOGSYS_LEVEL_DEBUG, "memb: get_extrainfo: allocated new buffer\n");
 	}
 
 	einfo->node_state = us->state;
@@ -580,6 +579,9 @@
 			struct sockaddr_in6 *saddr6;
 
 			objdb_get_string(corosync, object_handle, "mcastaddr", &mcast);
+			/* If this fails, it must be using broadcast*/
+			if (!mcast)
+				mcast = "255.255.255.255";
 			memset(ptr, 0, sizeof(struct sockaddr_storage));
 
 			saddr4 = (struct sockaddr_in *)ptr;
@@ -634,7 +636,7 @@
 		if ((retsize / sizeof(struct cl_cluster_node)) < total_nodes) {
 			*retbuf = malloc(sizeof(struct cl_cluster_node) * total_nodes + offset);
 			outbuf = *retbuf + offset;
-			P_MEMB("get_all_members: allocated new buffer (retsize=%d)\n", retsize);
+			log_printf(LOGSYS_LEVEL_DEBUG, "memb: get_all_members: allocated new buffer (retsize=%d)\n", retsize);
 		}
 	}
 	user_node = (struct cl_cluster_node *)outbuf;
@@ -656,7 +658,7 @@
 	}
 
 	*retlen = sizeof(struct cl_cluster_node) * num_nodes;
-	P_MEMB("get_all_members: retlen = %d\n", *retlen);
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: get_all_members: retlen = %d\n", *retlen);
 	return num_nodes;
 }
 
@@ -698,7 +700,7 @@
 			node = find_node_by_name(u_node->name);
 
 		if (!node) {
-			P_MEMB("cmd_get_node failed: id=%d, name='%s'\n", u_node->node_id, u_node->name);
+			log_printf(LOGSYS_LEVEL_DEBUG, "memb: cmd_get_node failed: id=%d, name='%s'\n", u_node->node_id, u_node->name);
 			return -ENOENT;
 		}
 	}
@@ -780,7 +782,7 @@
 {
 	struct cl_killmsg msg;
 
-	P_MEMB("Sending KILL to node %d\n", nodeid);
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: Sending KILL to node %d\n", nodeid);
 
 	msg.cmd = CLUSTER_MSG_KILLNODE;
 	msg.reason = reason;
@@ -796,7 +798,7 @@
 {
 	struct cl_leavemsg msg;
 
-	P_MEMB("Sending LEAVE, reason %d\n", reason);
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: Sending LEAVE, reason %d\n", reason);
 
 	msg.cmd = CLUSTER_MSG_LEAVE;
 	msg.reason = reason;
@@ -868,14 +870,14 @@
 	   a cluster that has been running for a while
 	*/
        	if (!get_port_bit(rem_node, 0)) {
-		P_MEMB("islistening, no data for node %d, sending PORTENQ\n", nodeid);
+		log_printf(LOGSYS_LEVEL_DEBUG, "memb: islistening, no data for node %d, sending PORTENQ\n", nodeid);
 		send_port_enquire(rem_node->node_id);
 
 		/* Admit our ignorance */
 		return -EBUSY;
 	}
 	else {
-		P_MEMB("islistening, for node %d, low bytes are %x %x\n", nodeid, rem_node->port_bits[0], rem_node->port_bits[1]);
+		log_printf(LOGSYS_LEVEL_DEBUG, "memb: islistening, for node %d, low bytes are %x %x\n", nodeid, rem_node->port_bits[0], rem_node->port_bits[1]);
 		return get_port_bit(rem_node, rq.port);
 	}
 }
@@ -897,7 +899,7 @@
 	if (!arg.nodeid)
 		arg.nodeid = us->node_id;
 
-	P_MEMB("Setting votes for node %d to %d\n", arg.nodeid, arg.newvotes);
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: Setting votes for node %d to %d\n", arg.nodeid, arg.newvotes);
 
 	node = find_node_by_nodeid(arg.nodeid);
 	if (!node)
@@ -928,7 +930,7 @@
 
 	memcpy(&port, cmdbuf, sizeof(int));
 
-	P_MEMB("requested bind to port %d, (us=%p)\n", port, con);
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: requested bind to port %d, (us=%p)\n", port, con);
 
 	if (port == 0 || port > 255)
 		return -EINVAL;
@@ -1004,14 +1006,14 @@
 			shutdown_con = NULL;
 		}
 
-		P_MEMB("shutdown decision is: %d (yes=%d, no=%d) flags=%x\n", reply, shutdown_yes, shutdown_no, shutdown_flags);
+		log_printf(LOGSYS_LEVEL_DEBUG, "memb: shutdown decision is: %d (yes=%d, no=%d) flags=%x\n", reply, shutdown_yes, shutdown_no, shutdown_flags);
 	}
 }
 
 /* Not all nodes responded to the shutdown */
 static void shutdown_timer_fn(void *arg)
 {
-	P_MEMB("Shutdown timer fired. flags = %x\n", shutdown_flags);
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: Shutdown timer fired. flags = %x\n", shutdown_flags);
 
 	/* Mark undecideds as "NO" */
 	shutdown_no = shutdown_expected;
@@ -1027,7 +1029,7 @@
 	if (!shutdown_con)
 		return -EWOULDBLOCK;
 
-	P_MEMB("Shutdown reply is %d\n", response);
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: Shutdown reply is %d\n", response);
 
 	/* We only need to keep a track of a client's response in
 	   case it pulls the connection before the shutdown process
@@ -1200,7 +1202,7 @@
 	if (!quorum_device || quorum_device->state == NODESTATE_DEAD)
 		return;
 
-	P_MEMB("quorum_device_timer_fn\n");
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: quorum_device_timer_fn\n");
 	gettimeofday(&now, NULL);
 	if (quorum_device->last_hello.tv_sec + quorumdev_poll/1000 < now.tv_sec) {
 		quorum_device->state = NODESTATE_DEAD;
@@ -1270,7 +1272,7 @@
 	strcpy(fence_msg->agent, f->fence_agent);
 	comms_send_message(msg, sizeof(msg), 0,0, 0, 0);
 
-	P_MEMB("node %d fenced by %s\n", f->nodeid, f->fence_agent);
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: node %d fenced by %s\n", f->nodeid, f->fence_agent);
 	return 0;
 }
 
@@ -1350,7 +1352,7 @@
 	char *outbuf = *retbuf;
 	int value;
 
-	P_MEMB("command to process is %x\n", cmd);
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: command to process is %x\n", cmd);
 
 	switch (cmd) {
 
@@ -1376,7 +1378,11 @@
 
 	case CMAN_CMD_SET_DEBUGLOG:
 		memcpy(&value, cmdbuf, sizeof(int));
-		set_debuglog(value);
+		/* sanitize input value */
+		if (value > 0)
+			value = 1;
+
+		logsys_config_debug_set(CMAN_NAME, value);
 		err = 0;
 		break;
 	case CMAN_CMD_START_CONFCHG:
@@ -1504,20 +1510,28 @@
 		err = do_cmd_get_node_addrs(cmdbuf, retbuf, retsize, retlen, offset);
 		break;
 	}
-	P_MEMB("command return code is %d\n", err);
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: command return code is %d\n", err);
 	return err;
 }
 
 
 int send_to_userport(unsigned char fromport, unsigned char toport,
 		     int nodeid, int tgtid,
-		     char *recv_buf, int len,
+		     const char *recv_buf, int len,
 		     int endian_conv)
 {
 	int ret = -1;
 
 	if (toport == 0) {
-		process_internal_message(recv_buf, nodeid, endian_conv);
+
+	  /* We need to make a private copy here so that the internal command
+	   * processors can do byteswapping.
+	   */
+	        char *newmsg = alloca(len);
+		if (!newmsg)
+		    return -1;
+		memcpy(newmsg, recv_buf, len);
+		process_internal_message(newmsg, nodeid, endian_conv);
 		ret = 0;
 	}
 	else {
@@ -1525,7 +1539,7 @@
 		if (port_array[toport]) {
 			struct connection *c = port_array[toport];
 
-			P_MEMB("send_to_userport. cmd=%d,  endian_conv=%d\n", recv_buf[0],endian_conv);
+			log_printf(LOGSYS_LEVEL_DEBUG, "memb: send_to_userport. cmd=%d,  endian_conv=%d\n", recv_buf[0],endian_conv);
 
 			send_data_reply(c, nodeid, fromport, recv_buf, len);
 			ret = 0;
@@ -1596,7 +1610,7 @@
 void unbind_con(struct connection *con)
 {
 	if (con->port) {
-		P_MEMB("Unbinding con for port %d\n", con->port);
+		log_printf(LOGSYS_LEVEL_DEBUG, "memb: Unbinding con for port %d\n", con->port);
 		port_array[con->port] = NULL;
 		send_port_close_msg(con->port);
 		clear_port_bit(us, con->port);
@@ -1697,7 +1711,7 @@
 
 	we_are_a_cluster_member = 1;
 
-	P_MEMB("sending TRANSITION message. cluster_name = %s\n", cluster_name);
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: sending TRANSITION message. cluster_name = %s\n", cluster_name);
 	msg->cmd = CLUSTER_MSG_TRANSITION;
 	msg->first_trans = first_trans;
 	msg->votes = us->votes;
@@ -1834,7 +1848,7 @@
 	struct cl_fencemsg *msg = data;
 	struct cluster_node *node;
 
-	P_DAEMON("got FENCE message, node %d fenced by %s\n", msg->nodeid, msg->agent);
+	log_printf(LOGSYS_LEVEL_DEBUG, "daemon: got FENCE message, node %d fenced by %s\n", msg->nodeid, msg->agent);
 
 	node = find_node_by_nodeid(msg->nodeid);
 	if (!node)
@@ -1861,7 +1875,7 @@
 	nodestate_t old_state;
 
 	if (valid_transition_msg(nodeid, msg) != 0) {
-		P_MEMB("Transition message from %d does not match current config - should quit ?\n", nodeid);
+		log_printf(LOGSYS_LEVEL_DEBUG, "memb: Transition message from %d does not match current config - should quit ?\n", nodeid);
 		// Now what ??
 		return;
 	}
@@ -1885,7 +1899,7 @@
 	old_expected = node->expected_votes;
 	old_state = node->state;
 
-	P_MEMB("Got TRANSITION message. msg->flags=%x, node->flags=%x, first_trans=%d\n",
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: Got TRANSITION message. msg->flags=%x, node->flags=%x, first_trans=%d\n",
 	       msg->flags, node->flags, msg->first_trans);
 
 	/* Newer nodes 6.1.0 onwards, set the DIRTY flag if they have state. If the new node has been down
@@ -1895,13 +1909,11 @@
 		/* Don't duplicate messages */
 		if (node->state != NODESTATE_AISONLY) {
 			if (cluster_is_quorate) {
-				P_MEMB("Killing node %s because it has rejoined the cluster with existing state", node->name);
 				log_printf(LOG_CRIT, "Killing node %s because it has rejoined the cluster with existing state", node->name);
 				node->state = NODESTATE_AISONLY;
 				send_kill(nodeid, CLUSTER_KILL_REJOIN);
 			}
 			else {
-				P_MEMB("Node %s not joined to cman because it has existing state", node->name);
 				log_printf(LOG_CRIT, "Node %s not joined to cman because it has existing state", node->name);
 				node->state = NODESTATE_AISONLY;
 			}
@@ -1916,13 +1928,11 @@
 		/* Don't duplicate messages */
 		if (node->state != NODESTATE_AISONLY) {
 			if (cluster_is_quorate) {
-				P_MEMB("Killing node %s because it has rejoined the cluster without cman_tool join", node->name);
 				log_printf(LOG_CRIT, "Killing node %s because it has rejoined the cluster without cman_tool join", node->name);
 				node->state = NODESTATE_AISONLY;
 				send_kill(nodeid, CLUSTER_KILL_REJOIN);
 			}
 			else {
-				P_MEMB("Node %s not joined to cman because it has rejoined an inquorate cluster", node->name);
 				log_printf(LOG_CRIT, "Node %s not joined to cman because it has rejoined an inquorate cluster", node->name);
 				node->state = NODESTATE_AISONLY;
 			}
@@ -1984,7 +1994,7 @@
 	struct cluster_node *node = find_node_by_nodeid(nodeid);
 	unsigned char portresult[PORT_BITS_SIZE+1];
 
-	P_MEMB("Message on port 0 is %d\n", msg->cmd);
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: Message on port 0 is %d\n", msg->cmd);
 
 	/* Byteswap messages if needed */
 	if (need_byteswap)
@@ -2008,7 +2018,7 @@
 	case CLUSTER_MSG_PORTENQ:
 		portresult[0] = CLUSTER_MSG_PORTSTATUS;
 		memcpy(portresult+1, us->port_bits, PORT_BITS_SIZE);
-		P_MEMB("Sending PORTRESULT, low bytes = %x %x\n", us->port_bits[0], us->port_bits[1]);
+		log_printf(LOGSYS_LEVEL_DEBUG, "memb: Sending PORTRESULT, low bytes = %x %x\n", us->port_bits[0], us->port_bits[1]);
 
 		/* Broadcast reply as other new nodes may be interested */
 		comms_send_message(portresult, PORT_BITS_SIZE+1, 0,0, 0, 0);
@@ -2016,20 +2026,20 @@
 
 	case CLUSTER_MSG_PORTSTATUS:
 		if (nodeid != us->node_id) {
-			P_MEMB("got PORTRESULT from %d, low bytes = %x %x\n", nodeid, data[1], data[2]);
+			log_printf(LOGSYS_LEVEL_DEBUG, "memb: got PORTRESULT from %d, low bytes = %x %x\n", nodeid, data[1], data[2]);
 			if (node)
 				memcpy(node->port_bits, data+1, PORT_BITS_SIZE);
 		}
 		break;
 
 	case CLUSTER_MSG_TRANSITION:
-		P_MEMB("got TRANSITION from node %d\n", nodeid);
+		log_printf(LOGSYS_LEVEL_DEBUG, "memb: got TRANSITION from node %d\n", nodeid);
 		do_process_transition(nodeid, data);
 		break;
 
 	case CLUSTER_MSG_KILLNODE:
 		killmsg = (struct cl_killmsg *)data;
-		P_MEMB("got KILL for node %d\n", killmsg->nodeid);
+		log_printf(LOGSYS_LEVEL_DEBUG, "memb: got KILL for node %d\n", killmsg->nodeid);
 		if (killmsg->nodeid == wanted_nodeid) {
 			/* Must use syslog directly here or the message will never arrive */
 			syslog(LOG_CRIT, "cman killed by node %d because %s\n", nodeid,
@@ -2041,7 +2051,7 @@
 
 	case CLUSTER_MSG_LEAVE:
 		leavemsg = (struct cl_leavemsg *)data;
-		P_MEMB("got LEAVE from node %d, reason = %d\n", nodeid, leavemsg->reason);
+		log_printf(LOGSYS_LEVEL_DEBUG, "memb: got LEAVE from node %d, reason = %d\n", nodeid, leavemsg->reason);
 
 		/* We got our own leave message back. now quit */
 		if (node && node->node_id == us->node_id) {
@@ -2049,7 +2059,7 @@
 			if (shutdown_con)
 				send_status_return(shutdown_con, CMAN_CMD_TRY_SHUTDOWN, 0);
 			cman_finish();
-			exit(0);
+			corosync_shutdown();
 		}
 
 		/* Someone else, make a note of the reason for leaving */
@@ -2134,12 +2144,12 @@
 {
 	struct cluster_node *node;
 
-	P_MEMB("add_ais_node ID=%d, incarnation = %" PRIu64 "\n",nodeid, incar);
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: add_ais_node ID=%d, incarnation = %" PRIu64 "\n",nodeid, incar);
 
 	node = find_node_by_nodeid(nodeid);
 	if (!node && total_members == 1) {
 		node = us;
-		P_MEMB("Adding AIS node for 'us'\n");
+		log_printf(LOGSYS_LEVEL_DEBUG, "memb: Adding AIS node for 'us'\n");
 	}
 
  	/* This really should exist!! */
@@ -2165,7 +2175,7 @@
 {
 	struct cluster_node *node;
 	time_t t;
-	P_MEMB("del_ais_node %d\n", nodeid);
+	log_printf(LOGSYS_LEVEL_DEBUG, "memb: del_ais_node %d\n", nodeid);
 
 	node = find_node_by_nodeid(nodeid);
 	if (!node)
@@ -2201,7 +2211,7 @@
 		memset(&node->port_bits, 0, sizeof(node->port_bits));
 		cluster_members--;
 
-		P_MEMB("del_ais_node %s, leave_reason=%x\n", node->name, node->leave_reason);
+		log_printf(LOGSYS_LEVEL_DEBUG, "memb: del_ais_node %s, leave_reason=%x\n", node->name, node->leave_reason);
 		if ((node->leave_reason & 0xF) == CLUSTER_LEAVEFLAG_REMOVED)
 			recalculate_quorum(1, 1);
 		else
diff -Naurd cluster-3.0.0.rc2/cman/daemon/commands.h cluster-3.0.0.rc3/cman/daemon/commands.h
--- cluster-3.0.0.rc2/cman/daemon/commands.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/daemon/commands.h	2009-06-11 11:02:55.000000000 +0200
@@ -5,7 +5,7 @@
 
 extern int send_to_userport(unsigned char fromport, unsigned char toport,
 			    int nodeid, int tgtnodeid,
-			    char *recv_buf, int len,
+			    const char *recv_buf, int len,
 			    int endian_conv);
 extern void clean_dead_listeners(void);
 extern void unbind_con(struct connection *con);
diff -Naurd cluster-3.0.0.rc2/cman/daemon/daemon.c cluster-3.0.0.rc3/cman/daemon/daemon.c
--- cluster-3.0.0.rc2/cman/daemon/daemon.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/daemon/daemon.c	2009-06-11 11:02:55.000000000 +0200
@@ -30,7 +30,6 @@
 #include "cnxman-socket.h"
 #include "cnxman-private.h"
 #include "daemon.h"
-#include "logging.h"
 #include "commands.h"
 #include "barrier.h"
 #include "ais.h"
@@ -64,7 +63,7 @@
 {
 	int ret;
 
-	P_DAEMON("sending reply %x to fd %d\n", msg->command, con->fd);
+	log_printf(LOGSYS_LEVEL_DEBUG, "daemon: sending reply %x to fd %d\n", msg->command, con->fd);
 
 	/* If there are already queued messages then don't send this one
 	   out of order */
@@ -82,7 +81,7 @@
 
 		/* Have we exceeded the allowed number of queued messages ? */
 		if (con->num_write_msgs > max_outstanding_messages) {
-			P_DAEMON("Disconnecting. client has more that %d replies outstanding (%d)\n", max_outstanding_messages, con->num_write_msgs);
+			log_printf(LOGSYS_LEVEL_DEBUG, "daemon: Disconnecting. client has more that %d replies outstanding (%d)\n", max_outstanding_messages, con->num_write_msgs);
 			remove_client(cs_poll_handle, con);
 			return -1;
 		}
@@ -101,7 +100,7 @@
 			qm->offset = 0;
 		list_add(&con->write_msgs, &qm->list);
 		con->num_write_msgs++;
-		P_DAEMON("queued last message, count is %d\n", con->num_write_msgs);
+		log_printf(LOGSYS_LEVEL_DEBUG, "daemon: queued last message, count is %d\n", con->num_write_msgs);
 		poll_dispatch_modify(cs_poll_handle, con->fd, POLLIN | POLLOUT, process_client);
 	}
 	return 0;
@@ -129,7 +128,7 @@
 		msgs++;
 	}
 
-	P_DAEMON("Freed %d queued messages\n", msgs);
+	log_printf(LOGSYS_LEVEL_DEBUG, "daemon: Freed %d queued messages\n", msgs);
 	free(con);
 	num_connections--;
 }
@@ -161,7 +160,7 @@
 	}
 	if (list_empty(&con->write_msgs)) {
 		/* Remove POLLOUT callback */
-		P_DAEMON("Removing POLLOUT from fd %d\n", con->fd);
+		log_printf(LOGSYS_LEVEL_DEBUG, "daemon: Removing POLLOUT from fd %d\n", con->fd);
 		poll_dispatch_modify(cs_poll_handle, con->fd, POLLIN, process_client);
 	}
 }
@@ -183,7 +182,7 @@
 
 		len = read(fd, buf, sizeof(struct sock_header));
 
-		P_DAEMON("read %d bytes from fd %d\n", len, fd);
+		log_printf(LOGSYS_LEVEL_DEBUG, "daemon: read %d bytes from fd %d\n", len, fd);
 
 		if (len == 0) {
 			remove_client(handle, con);
@@ -200,17 +199,17 @@
 		}
 
 		if (msg->magic != CMAN_MAGIC) {
-			P_DAEMON("bad magic in client command %x\n", msg->magic);
+			log_printf(LOGSYS_LEVEL_DEBUG, "daemon: bad magic in client command %x\n", msg->magic);
 			send_status_return(con, msg->command, -EINVAL);
 			return 0;
 		}
 		if (msg->version != CMAN_VERSION) {
-			P_DAEMON("bad version in client command. msg = 0x%x, us = 0x%x\n", msg->version, CMAN_VERSION);
+			log_printf(LOGSYS_LEVEL_DEBUG, "daemon: bad version in client command. msg = 0x%x, us = 0x%x\n", msg->version, CMAN_VERSION);
 			send_status_return(con, msg->command, -EINVAL);
 			return 0;
 		}
 		if ((msg->length-len) > MAX_CLUSTER_MESSAGE) {
-			P_DAEMON("message on socket is too big\n");
+			log_printf(LOGSYS_LEVEL_DEBUG, "daemon: message on socket is too big\n");
 			send_status_return(con, msg->command, -EINVAL);
 			return 0;
 		}
@@ -234,11 +233,11 @@
 			totallen += len;
 		}
 
-		P_DAEMON("client command is %x\n", msg->command);
+		log_printf(LOGSYS_LEVEL_DEBUG, "daemon: client command is %x\n", msg->command);
 
 		/* Privileged functions can only be done on ADMIN sockets */
 		if (msg->command & CMAN_CMDFLAG_PRIV && con->type != CON_ADMIN) {
-			P_DAEMON("command disallowed from non-admin client\n");
+			log_printf(LOGSYS_LEVEL_DEBUG, "daemon: command disallowed from non-admin client\n");
 			send_status_return(con, msg->command, -EPERM);
 			return 0;
 		}
@@ -249,7 +248,7 @@
 		*/
 		if ((msg->command == CMAN_CMD_DATA || msg->command == CMAN_CMD_BIND ||
 		     msg->command == CMAN_CMD_NOTIFY) && con->type == CON_ADMIN) {
-			P_DAEMON("can't send data down an admin socket, sorry\n");
+			log_printf(LOGSYS_LEVEL_DEBUG, "daemon: can't send data down an admin socket, sorry\n");
 			send_status_return(con, msg->command, -EINVAL);
 			return 0;
 		}
@@ -260,7 +259,7 @@
 			uint8_t port;
 			struct sock_data_header *dmsg = (struct sock_data_header *)msg;
 
-			P_DAEMON("sending %lu bytes of data to node %d, port %d\n",
+			log_printf(LOGSYS_LEVEL_DEBUG, "daemon: sending %lu bytes of data to node %d, port %d\n",
 				 (unsigned long)(msg->length - sizeof(struct sock_data_header)), dmsg->nodeid, dmsg->port);
 
 			databuf += sizeof(struct sock_data_header);
@@ -291,7 +290,7 @@
 			int ret;
 			int retlen = 0;
 
-			P_DAEMON("About to process command\n");
+			log_printf(LOGSYS_LEVEL_DEBUG, "daemon: About to process command\n");
 
 			cmdbuf += sizeof(struct sock_header);
 
@@ -311,7 +310,7 @@
 			reply->header.length = retlen + sizeof(struct sock_reply_header);
 			reply->status = ret;
 
-			P_DAEMON("Returning command data. length = %d\n", retlen);
+			log_printf(LOGSYS_LEVEL_DEBUG, "daemon: Returning command data. length = %d\n", retlen);
 			send_reply_message(con, (struct sock_header *)reply);
 
 			if (retbuf != small_retbuf)
@@ -415,7 +414,7 @@
 {
 	struct sock_reply_header msg;
 
-	P_DAEMON("send status return: %d\n", status);
+	log_printf(LOGSYS_LEVEL_DEBUG, "daemon: send status return: %d\n", status);
 	msg.header.magic = CMAN_MAGIC;
 	msg.header.command = cmd | CMAN_CMDFLAG_REPLY;
 	msg.header.length = sizeof(msg);
@@ -425,7 +424,7 @@
 	return send_reply_message(con, (struct sock_header *)&msg);
 }
 
-int send_data_reply(struct connection *con, int nodeid, int port, char *data, int len)
+int send_data_reply(struct connection *con, int nodeid, int port, const char *data, int len)
 {
 	char buf[len + sizeof(struct sock_data_header)];
 	struct sock_data_header *msg = (struct sock_data_header *)buf;
diff -Naurd cluster-3.0.0.rc2/cman/daemon/daemon.h cluster-3.0.0.rc3/cman/daemon/daemon.h
--- cluster-3.0.0.rc2/cman/daemon/daemon.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/daemon/daemon.h	2009-06-11 11:02:55.000000000 +0200
@@ -1,5 +1,5 @@
 extern int send_status_return(struct connection *con, uint32_t cmd, int status);
-extern int send_data_reply(struct connection *con, int nodeid, int port, char *data, int len);
+extern int send_data_reply(struct connection *con, int nodeid, int port, const char *data, int len);
 extern void set_cman_timeout(int secs);
 extern void notify_listeners(struct connection *con, int reason, int arg);
 extern int num_listeners(void);
diff -Naurd cluster-3.0.0.rc2/cman/daemon/Makefile cluster-3.0.0.rc3/cman/daemon/Makefile
--- cluster-3.0.0.rc2/cman/daemon/Makefile	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/daemon/Makefile	2009-06-11 11:02:55.000000000 +0200
@@ -18,7 +18,6 @@
 LDFLAGS += -L${libdir}
 
 OBJS1=	daemon.o \
-	logging.o \
 	ais.o \
 	commands.o \
 	barrier.o \
diff -Naurd cluster-3.0.0.rc2/cman/init.d/cman.in cluster-3.0.0.rc3/cman/init.d/cman.in
--- cluster-3.0.0.rc2/cman/init.d/cman.in	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/init.d/cman.in	2009-06-11 11:02:55.000000000 +0200
@@ -122,7 +122,16 @@
 #     The default script is "network-bridge".
 [ -z "$NETWORK_BRIDGE_SCRIPT" ] && NETWORK_BRIDGE_SCRIPT="network-bridge"
 
-[ -n "$CLUSTERNAME" ] && cman_join_opts="-c $CLUSTERNAME"
+# CMAN_JOIN_OPTS -- allows extra options to be passed to cman_tool when join
+#     operation is performed.
+#     NOTES:
+#	$CLUSTERNAME   automatically appends "-c $CLUSTERNAME"
+#	$NODENAME      automatically appends "-n $NODENAME"
+#	$CONFIG_LOADER automatically appends "-C $CONFIG_LOADER"
+
+[ -n "$CMAN_JOIN_OPTS" ] && cman_join_opts="$CMAN_JOIN_OPTS"
+
+[ -n "$CLUSTERNAME" ] && cman_join_opts+="-c $CLUSTERNAME"
 
 [ -n "$NODENAME" ] && cman_join_opts+=" -n $NODENAME"
 
@@ -139,6 +148,10 @@
 # openaisparser   - use internal openais config file parser.
 [ -n "$CONFIG_LOADER" ] && cman_join_opts+=" -C $CONFIG_LOADER"
 
+# CMAN_LEAVE_OPTS -- allows extra options to be passed to cman_tool when leave
+#     operation is performed.
+[ -n "$CMAN_LEAVE_OPTS" ] && cman_leave_opts="$CMAN_LEAVE_OPTS"
+
 # INITLOGLEVEL -- select how verbose the init script should be
 # possible values:
 # quiet           - only one line notification for start/stop operations
@@ -477,7 +490,7 @@
 stop_cman()
 {
 	if cman_running; then
-		errmsg=$( cman_tool -t $CMAN_SHUTDOWN_TIMEOUT \
+		errmsg=$( cman_tool $cman_leave_opts -t $CMAN_SHUTDOWN_TIMEOUT \
 			-w leave $cmanremove 2>&1 ) || return 1
 	fi
 }
diff -Naurd cluster-3.0.0.rc2/cman/qdisk/disk.c cluster-3.0.0.rc3/cman/qdisk/disk.c
--- cluster-3.0.0.rc2/cman/qdisk/disk.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/qdisk/disk.c	2009-06-11 11:02:55.000000000 +0200
@@ -27,6 +27,7 @@
 #include <linux/fs.h>
 #include <liblogthread.h>
 #include <zlib.h>
+#include "iostate.h"
 
 static int diskRawRead(target_info_t *disk, char *buf, int len);
 
@@ -229,7 +230,9 @@
 	disk->d_pagesz = sysconf(_SC_PAGESIZE);
 
 	/* Check to verify that the partition is large enough.*/
+	io_state(STATE_LSEEK);
 	ret = lseek(disk->d_fd, END_OF_DISK(disk->d_blksz), SEEK_SET);
+	io_state(STATE_NONE);
 	if (ret < 0) {
 		logt_print(LOG_DEBUG, "open_partition: seek");
 		close(disk->d_fd);
@@ -332,7 +335,9 @@
 	shared_header_t *hdrp;
 	char *data;
 
+	io_state(STATE_LSEEK);
 	ret = lseek(disk->d_fd, readOffset, SEEK_SET);
+	io_state(STATE_NONE);
 	if (ret != readOffset) {
 		logt_print(LOG_DEBUG,
 		       "diskRawReadShadow: can't seek to offset %d.\n",
@@ -354,11 +359,9 @@
 	data = (char *)buf + sizeof(*hdrp);
 
 	if (header_verify(hdrp, data, len)) {
-#ifdef DEBUG
 		logt_print(LOG_DEBUG, "diskRawReadShadow: bad CRC32, "
 		       "offset = %d len = %d\n",
 		       (int) readOffset, len);
-#endif
 		errno = EPROTO;
 		return -1;
 	}
@@ -391,7 +394,10 @@
 	if (bounceNeeded == 0) {
 		/* Already aligned and even multiple of 512, no bounceio
 		 * required. */
-		return (read(disk->d_fd, buf, len));
+		io_state(STATE_READ);
+		readret = read(disk->d_fd, buf, len);
+		io_state(STATE_NONE);
+		return readret;
 	}
 
 	if (len > disk->d_blksz) {
@@ -420,7 +426,9 @@
 		return -1;
 	}
 
+	io_state(STATE_READ);
 	readret = read(disk->d_fd, alignedBuf, readlen);
+	io_state(STATE_NONE);
 	if (readret > 0) {
 		if (readret > len) {
 			memcpy(alignedBuf, buf, len);
@@ -463,7 +471,10 @@
 	if (bounceNeeded == 0) {
 		/* Already aligned and even multiple of 512, no bounceio
 		 * required. */
-		return (write(disk->d_fd, buf, len));
+		io_state(STATE_WRITE);
+		ret = write(disk->d_fd, buf, len);
+		io_state(STATE_NONE);
+		return ret;
 	}
 
 	if (len > disk->d_blksz) {
@@ -500,7 +511,9 @@
 	}
 
 	memcpy(buf, alignedBuf, len);
+	io_state(STATE_WRITE);
 	ret = write(disk->d_fd, alignedBuf, writelen);
+	io_state(STATE_NONE);
 	if (ret > len) {
 		ret = len;
 	}
@@ -528,7 +541,9 @@
 		return (-1);
 	}
 
+	io_state(STATE_LSEEK);
 	retval_seek = lseek(disk->d_fd, writeOffset, SEEK_SET);
+	io_state(STATE_NONE);
 	if (retval_seek != writeOffset) {
 		logt_print(LOG_ERR,
 		       "diskRawWriteShadow: can't seek to offset %d\n",
diff -Naurd cluster-3.0.0.rc2/cman/qdisk/iostate.c cluster-3.0.0.rc3/cman/qdisk/iostate.c
--- cluster-3.0.0.rc2/cman/qdisk/iostate.c	1970-01-01 01:00:00.000000000 +0100
+++ cluster-3.0.0.rc3/cman/qdisk/iostate.c	2009-06-11 11:02:55.000000000 +0200
@@ -0,0 +1,142 @@
+#include <pthread.h>
+#include <iostate.h>
+#include <unistd.h>
+#include <time.h>
+#include <sys/time.h>
+#include <liblogthread.h>
+#include "iostate.h"
+
+static iostate_t main_state = 0;
+static int main_incarnation = 0;
+static int qdisk_timeout = 0, sleeptime = 0;
+static int thread_active = 0;
+static pthread_t io_nanny_tid = 0;
+static pthread_mutex_t state_mutex = PTHREAD_MUTEX_INITIALIZER;
+static pthread_cond_t state_cond = PTHREAD_COND_INITIALIZER;
+
+struct state_table {
+	iostate_t state;
+	const char *value;
+};
+
+static struct state_table io_state_table[] = {
+{	STATE_NONE,	"none"	},
+{	STATE_WRITE,	"write"	},
+{	STATE_READ,	"read"	},
+{	STATE_LSEEK,	"seek"	},
+{	-1,		NULL	} };
+
+static const char *
+state_to_string(iostate_t state)
+{
+	static const char *ret = "unknown";
+	int i;
+
+	for (i=0; io_state_table[i].value; i++) {
+		if (io_state_table[i].state == state) {
+			ret = io_state_table[i].value;
+			break;
+		}
+	}
+
+	return ret;
+}
+
+
+void
+io_state(iostate_t state)
+{
+	pthread_mutex_lock(&state_mutex);
+	main_state = state;
+	main_incarnation++; /* it does not matter if this wraps. */
+	pthread_mutex_unlock(&state_mutex);
+
+	/* Optimization: Don't signal on STATE_NONE */
+	if (state != STATE_NONE)
+		pthread_cond_broadcast(&state_cond);
+}
+
+
+static void *
+io_nanny_thread(void *arg)
+{
+	struct timespec wait_time;
+	iostate_t last_main_state = 0, current_main_state = 0;
+	int last_main_incarnation = 0, current_main_incarnation = 0;
+	int logged_incarnation = 0;
+
+	/* Start with wherever we're at now */
+	pthread_mutex_lock(&state_mutex);
+	current_main_state = last_main_state = main_state;
+	current_main_incarnation = last_main_incarnation = main_incarnation;
+	pthread_mutex_unlock(&state_mutex);
+
+	while (thread_active) {
+		pthread_mutex_lock(&state_mutex);
+    		clock_gettime(CLOCK_REALTIME, &wait_time);
+		wait_time.tv_sec += sleeptime;
+		pthread_cond_timedwait(&state_cond, &state_mutex, &wait_time);
+		current_main_state = main_state;
+		current_main_incarnation = main_incarnation;
+		pthread_mutex_unlock(&state_mutex);
+
+		if (!thread_active)
+			break;
+
+		if (!current_main_state)
+			continue;
+
+		/* if the state or incarnation changed, the main qdiskd
+		 * thread is healthy */
+		if (current_main_state != last_main_state ||
+		    current_main_incarnation != last_main_incarnation) {
+			last_main_state = current_main_state;
+			last_main_incarnation = current_main_incarnation;
+			continue;
+		}
+
+		/* Don't log things twice */
+		if (logged_incarnation == current_main_incarnation)
+			continue;
+		logged_incarnation = current_main_incarnation;
+
+		logt_print(LOG_WARNING, "qdiskd: %s "
+			   "(system call) has hung for %d seconds\n",
+			   state_to_string(current_main_state), sleeptime);
+		logt_print(LOG_WARNING,
+			   "In %d more seconds, we will be evicted\n",
+			   (qdisk_timeout-sleeptime));
+	}
+
+	return NULL;
+}
+
+
+int
+io_nanny_start(int timeout)
+{
+	int ret;
+
+	pthread_mutex_lock(&state_mutex);
+
+	sleeptime = timeout / 2;
+	qdisk_timeout = timeout;
+	thread_active = 1;
+
+	ret = pthread_create(&io_nanny_tid, NULL, io_nanny_thread, NULL);
+	pthread_mutex_unlock(&state_mutex);
+
+	return ret;
+}
+
+
+int
+io_nanny_stop(void)
+{
+	thread_active = 0;
+	pthread_cond_broadcast(&state_cond);
+	pthread_join(io_nanny_tid, NULL);
+	io_nanny_tid = 0;
+
+	return 0;
+}
diff -Naurd cluster-3.0.0.rc2/cman/qdisk/iostate.h cluster-3.0.0.rc3/cman/qdisk/iostate.h
--- cluster-3.0.0.rc2/cman/qdisk/iostate.h	1970-01-01 01:00:00.000000000 +0100
+++ cluster-3.0.0.rc3/cman/qdisk/iostate.h	2009-06-11 11:02:55.000000000 +0200
@@ -0,0 +1,17 @@
+#ifndef _IOSTATE_H
+#define _IOSTATE_H
+
+typedef enum {
+	STATE_NONE	= 0,
+	STATE_READ	= 1,
+	STATE_WRITE	= 2,
+	STATE_LSEEK	= 3,
+	STATE_UNKNOWN	= 4
+} iostate_t;
+
+void io_state(iostate_t state);
+
+int io_nanny_start(int timeout);
+int io_nanny_stop(void);
+
+#endif
diff -Naurd cluster-3.0.0.rc2/cman/qdisk/main.c cluster-3.0.0.rc3/cman/qdisk/main.c
--- cluster-3.0.0.rc2/cman/qdisk/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/qdisk/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -28,6 +28,8 @@
 
 #define LOG_DAEMON_NAME  "qdiskd"
 #define LOG_MODE_DEFAULT LOG_MODE_OUTPUT_SYSLOG|LOG_MODE_OUTPUT_FILE
+#include "iostate.h"
+
 
 /* from main.c */
 void set_priority(int queue, int prio);
@@ -1793,9 +1795,14 @@
 		goto out;
 	}
 	*/
+
+	io_nanny_start(ctx.qc_tko * ctx.qc_interval);
+
 	if (quorum_loop(&ctx, ni, MAX_NODES_DISK) == 0)
 		cman_unregister_quorum_device(ctx.qc_cman_admin);
 
+	io_nanny_stop();
+
 	quorum_logout(&ctx);
 out:
 	/* free cman handle to avoid leak in cman */
diff -Naurd cluster-3.0.0.rc2/cman/qdisk/Makefile cluster-3.0.0.rc3/cman/qdisk/Makefile
--- cluster-3.0.0.rc2/cman/qdisk/Makefile	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/cman/qdisk/Makefile	2009-06-11 11:02:55.000000000 +0200
@@ -12,14 +12,13 @@
 include $(OBJDIR)/make/uninstall.mk
 
 CFLAGS += -D_GNU_SOURCE
-CFLAGS += -Werror -Wstrict-prototypes -Wshadow
 CFLAGS += -I${ccsincdir} -I${cmanincdir} -I${logtincdir}
 CFLAGS += -I${zlibincdir} 
 CFLAGS += -I$(S)
 CFLAGS += -I${incdir}
 
 LDFLAGS += -L${logtlibdir} -llogthread -lpthread
-LDFLAGS += -L${zliblibdir} -lz
+LDFLAGS += -L${zliblibdir} -lz -lrt
 LDFLAGS += -L${libdir}
 
 EXTRA_LDFLAGS += -L${cmanlibdir} -L${ccslibdir} -lcman -lccs
@@ -34,7 +33,8 @@
 SHAREDOBJS= disk.o \
 	    disk_util.o \
 	    proc.o \
-	    scandisk.o
+	    scandisk.o \
+	    iostate.o
 
 ${TARGET1}: ${SHAREDOBJS} ${OBJS1}
 	$(CC) -o $@ $^ $(EXTRA_LDFLAGS) $(LDFLAGS)
